/*
 * font.c
 *
 * Created: 29.08.2019 09:31:35
 *  Author: M43909
 */

#include <stdint.h>
#include "font.h"
#include "bitmapDB.h"
//
//  Font data for Tahoma 8pt
//

// Character bitmaps for Tahoma 8pt
const uint8_t Bitmaps[] =
{
	// @0 '0' (5 pixels wide)
	0x00, //
	0x00, //
	0x70, //  ###
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x70, //  ###
	0x00, //

	// @11 '1' (3 pixels wide)
	0x00, //
	0x00, //
	0xE0, // ###
	0x40, //  #
	0x40, //  #
	0x40, //  #
	0x40, //  #
	0x40, //  #
	0xC0, // ##
	0x40, //  #
	0x00, //

	// @22 '2' (5 pixels wide)
	0x00, //
	0x00, //
	0xF8, // #####
	0x80, // #
	0x40, //  #
	0x20, //   #
	0x10, //    #
	0x08, //     #
	0x88, // #   #
	0x70, //  ###
	0x00, //

	// @33 '9' (5 pixels wide)
	0x00, //
	0x00, //
	0x60, //  ##
	0x10, //    #
	0x08, //     #
	0x78, //  ####
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x70, //  ###
	0x00, //

	// @44 'F' (5 pixels wide)
	0x00, //
	0x00, //
	0x80, // #
	0x80, // #
	0x80, // #
	0x80, // #
	0xF8, // #####
	0x80, // #
	0x80, // #
	0xF8, // #####
	0x00, //

	// @55 'M' (7 pixels wide)
	0x00, //
	0x00, //
	0x82, // #     #
	0x82, // #     #
	0x92, // #  #  #
	0x92, // #  #  #
	0xAA, // # # # #
	0xAA, // # # # #
	0xC6, // ##   ##
	0xC6, // ##   ##
	0x00, //

	// @66 'T' (5 pixels wide)
	0x00, //
	0x00, //
	0x20, //   #
	0x20, //   #
	0x20, //   #
	0x20, //   #
	0x20, //   #
	0x20, //   #
	0x20, //   #
	0xF8, // #####
	0x00, //

	// @77 'a' (5 pixels wide)
	0x00, //
	0x00, //
	0x78, //  ####
	0x88, // #   #
	0x88, // #   #
	0x78, //  ####
	0x08, //     #
	0x70, //  ###
	0x00, //
	0x00, //
	0x00, //

	// @88 'c' (4 pixels wide)
	0x00, //
	0x00, //
	0x70, //  ###
	0x80, // #
	0x80, // #
	0x80, // #
	0x80, // #
	0x70, //  ###
	0x00, //
	0x00, //
	0x00, //

	// @99 'd' (5 pixels wide)
	0x00, //
	0x00, //
	0x78, //  ####
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x78, //  ####
	0x08, //     #
	0x08, //     #
	0x08, //     #

	// @110 'e' (5 pixels wide)
	0x00, //
	0x00, //
	0x70, //  ###
	0x88, // #   #
	0x80, // #
	0xF8, // #####
	0x88, // #   #
	0x70, //  ###
	0x00, //
	0x00, //
	0x00, //

	// @121 'h' (5 pixels wide)
	0x00, //
	0x00, //
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0xF0, // ####
	0x80, // #
	0x80, // #
	0x80, // #

	// @132 'i' (1 pixels wide)
	0x00, //
	0x00, //
	0x80, // #
	0x80, // #
	0x80, // #
	0x80, // #
	0x80, // #
	0x80, // #
	0x00, //
	0x80, // #
	0x00, //

	// @143 'k' (5 pixels wide)
	0x00, //
	0x00, //
	0x88, // #   #
	0x90, // #  #
	0xA0, // # #
	0xC0, // ##
	0xA0, // # #
	0x90, // #  #
	0x80, // #
	0x80, // #
	0x80, // #

	// @154 'm' (7 pixels wide)
	0x00, //
	0x00, //
	0x92, // #  #  #
	0x92, // #  #  #
	0x92, // #  #  #
	0x92, // #  #  #
	0x92, // #  #  #
	0xEC, // ### ##
	0x00, //
	0x00, //
	0x00, //

	// @165 'n' (5 pixels wide)
	0x00, //
	0x00, //
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0xF0, // ####
	0x00, //
	0x00, //
	0x00, //

	// @176 'o' (5 pixels wide)
	0x00, //
	0x00, //
	0x70, //  ###
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x70, //  ###
	0x00, //
	0x00, //
	0x00, //

	// @187 'p' (5 pixels wide)
	0x80, // #
	0x80, // #
	0xF0, // ####
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0x88, // #   #
	0xF0, // ####
	0x00, //
	0x00, //
	0x00, //

	// @198 'r' (3 pixels wide)
	0x00, //
	0x00, //
	0x80, // #
	0x80, // #
	0x80, // #
	0x80, // #
	0xC0, // ##
	0xA0, // # #
	0x00, //
	0x00, //
	0x00, //
};

// Character descriptors for Tahoma 8pt
// { [Char width in bits], [Char height in bits], [Offset into tahoma_8ptCharBitmaps in bytes] }
const FONT_CHAR_INFO Descriptors[] =
{
	{5, 11, 0}, 		// 0
	{3, 11, 11}, 		// 1
	{5, 11, 22}, 		// 2
	{0, 0, 0}, 		// 3
	{0, 0, 0}, 		// 4
	{0, 0, 0}, 		// 5
	{0, 0, 0}, 		// 6
	{0, 0, 0}, 		// 7
	{0, 0, 0}, 		// 8
	{5, 11, 33}, 		// 9
	{0, 0, 0}, 		// :
	{0, 0, 0}, 		// ;
	{0, 0, 0}, 		// <
	{0, 0, 0}, 		// =
	{0, 0, 0}, 		// >
	{0, 0, 0}, 		// ?
	{0, 0, 0}, 		// @
	{0, 0, 0}, 		// A
	{0, 0, 0}, 		// B
	{0, 0, 0}, 		// C
	{0, 0, 0}, 		// D
	{0, 0, 0}, 		// E
	{5, 11, 44}, 		// F
	{0, 0, 0}, 		// G
	{0, 0, 0}, 		// H
	{0, 0, 0}, 		// I
	{0, 0, 0}, 		// J
	{0, 0, 0}, 		// K
	{0, 0, 0}, 		// L
	{7, 11, 55}, 		// M
	{0, 0, 0}, 		// N
	{0, 0, 0}, 		// O
	{0, 0, 0}, 		// P
	{0, 0, 0}, 		// Q
	{0, 0, 0}, 		// R
	{0, 0, 0}, 		// S
	{5, 11, 66}, 		// T
	{0, 0, 0}, 		// U
	{0, 0, 0}, 		// V
	{0, 0, 0}, 		// W
	{0, 0, 0}, 		// X
	{0, 0, 0}, 		// Y
	{0, 0, 0}, 		// Z
	{0, 0, 0}, 		// [
	{0, 0, 0}, 		//
	{0, 0, 0}, 		// ]
	{0, 0, 0}, 		// ^
	{0, 0, 0}, 		// _
	{0, 0, 0}, 		// `
	{5, 11, 77}, 		// a
	{0, 0, 0}, 		// b
	{4, 11, 88}, 		// c
	{5, 11, 99}, 		// d
	{5, 11, 110}, 		// e
	{0, 0, 0}, 		// f
	{0, 0, 0}, 		// g
	{5, 11, 121}, 		// h
	{1, 11, 132}, 		// i
	{0, 0, 0}, 		// j
	{5, 11, 143}, 		// k
	{0, 0, 0}, 		// l
	{7, 11, 154}, 		// m
	{5, 11, 165}, 		// n
	{5, 11, 176}, 		// o
	{5, 11, 187}, 		// p
	{0, 0, 0}, 		// q
	{3, 11, 198}, 		// r
};

// Font information for Tahoma 8pt
const FONT_INFO FontInfo =
{
	11, //  Character height
	'0', //  Start character
	'r', //  End character
	2, //  Width, in pixels, of space character
	Descriptors, //  Character descriptor array
	Bitmaps, //  Character bitmap array
};



